# frozen_string_literal: true

require_relative '../command'

module Sumcli
  module Commands
    class New < Sumcli::Command
      def initialize(name, options)
        @name = name
        @options = options
      end

      def execute(input: $stdin, output: $stdout)
        output.puts "OK"

        unless @name.nil? or File.directory?(@name)
          directory = File.expand_path('../../templates/new/app', __FILE__)
          generator.copy_directory(directory, @name)
          return File.chmod(0744, "#{@name}/bin/console")
        end

        output.puts "Directory #{@name} already exists."
      end
    end
  end
end
